import { Entity, EntityNames } from ".";
import { BoundingBox, Colliding, Grid, Sprite } from "../components";
import { IMAGES, SPRITE_SPECS, SpriteSpec, Sprites } from "../config";
import { Coord2D } from "../interfaces";

export class LockedDoor extends Entity {
  private static spriteSpec: SpriteSpec = SPRITE_SPECS.get(
    Sprites.LOCKED_DOOR,
  ) as SpriteSpec;

  constructor(gridPosition: Coord2D) {
    super(EntityNames.LockedDoor);

    this.addComponent(new Grid(gridPosition));

    this.addComponent(new Colliding());

    this.addComponent(
      new BoundingBox(
        {
          x: 0,
          y: 0,
        },
        {
          width: LockedDoor.spriteSpec.width,
          height: LockedDoor.spriteSpec.height,
        },
        0,
      ),
    );

    this.addComponent(
      new Sprite(
        IMAGES.get(LockedDoor.spriteSpec.sheet)!,
        { x: 0, y: 0 },
        {
          width: LockedDoor.spriteSpec.width,
          height: LockedDoor.spriteSpec.height,
        },
        LockedDoor.spriteSpec.msPerFrame,
        LockedDoor.spriteSpec.frames,
      ),
    );
  }
}
